#include "index_sort.h"


/********************************************************************************************/
void sort_double_up(double *werte, int *indizes, int anzahl)
{
	double pivot=werte[0];
	double temp;
	int left=0;
	int right=anzahl-1;
	int i, j, k;

        for( i=0; i < anzahl; i++) {
		indizes[i]=i;
	}

	while(left<=right)
	{
		while(werte[indizes[left]]<pivot)
			left++;
		while(werte[indizes[right]]>pivot)
			right--;
		if(left<=right)
		{
			if(left<right)
			{
				temp=indizes[left];
				indizes[left]=indizes[right];
				indizes[right]=temp;
			}
			left++;
			right--;
		}
	}
	if(0<right)
		sort_double_up_kernel(werte, indizes, 0, right);
	if(anzahl-1>left)
		sort_double_up_kernel(werte, indizes, left, anzahl-1);
}
/********************************************************************************************/
void sort_double_up_kernel(double *werte, int *indizes, int l, int r)
{
	double pivot=werte[indizes[l]];
	double temp;
	int left=l;
	int right=r;
	int i, j, k;

	while(left<=right)
	{
		while(werte[indizes[left]]<pivot)
			left++;
		while(werte[indizes[right]]>pivot)
			right--;
		if(left<=right)
		{
			if(left<right)
			{
				temp=indizes[left];
				indizes[left]=indizes[right];
				indizes[right]=temp;
			}
			left++;
			right--;
		}
	}
	if(l<right)
		sort_double_up_kernel(werte, indizes, l, right);
	if(r>left)
		sort_double_up_kernel(werte, indizes, left, r);
}
/********************************************************************************************/
void sort_int_up(int *werte, int *indizes, int anzahl)
{
	int pivot=werte[0];
	int temp;
	int left=0;
	int right=anzahl-1;
	int i, j, k;

        for( i=0; i < anzahl; i++) {
		indizes[i]=i;
	}

	while(left<=right)
	{
		while(werte[indizes[left]]<pivot)
			left++;
		while(werte[indizes[right]]>pivot)
			right--;
		if(left<=right)
		{
			if(left<right)
			{
				temp=indizes[left];
				indizes[left]=indizes[right];
				indizes[right]=temp;
			}
			left++;
			right--;
		}
	}
	if(0<right)
		sort_int_up_kernel(werte, indizes, 0, right);
	if(anzahl-1>left)
		sort_int_up_kernel(werte, indizes, left, anzahl-1);
}
/********************************************************************************************/
void sort_int_up_kernel(int *werte, int *indizes, int l, int r)
{
	int pivot=werte[indizes[l]];
	int temp;
	int left=l;
	int right=r;
	int i, j, k;

	while(left<=right)
	{
		while(werte[indizes[left]]<pivot)
			left++;
		while(werte[indizes[right]]>pivot)
			right--;
		if(left<=right)
		{
			if(left<right)
			{
				temp=indizes[left];
				indizes[left]=indizes[right];
				indizes[right]=temp;
			}
			left++;
			right--;
		}
	}
	if(l<right)
		sort_int_up_kernel(werte, indizes, l, right);
	if(r>left)
		sort_int_up_kernel(werte, indizes, left, r);
}
/********************************************************************************************/
