#ifndef sparse_values_DEF
   #define sparse_values_DEF
   #include "sparse_values.h"
#endif
#ifndef exchange_DEF
   #define exchange_DEF
   #include "exchange.h"
#endif
#ifndef timing_DEF
   #define timing_DEF
   #include "timing.h"
#endif
#include <stdlib.h>
#include <stdio.h>

/**************************************************************************************/
void alloc_sparse_values_type(sparse_values_type * aa, int length, int inner_length) {
 if ( length <  0 ) {
   printf("PE%i:\t error in routine alloc_sparse_values_type:");
   printf("PE%i:\t length=%d \n",my_rank, length);
   printf("PE%i:\t is less than 0!");
       exit_MPI(1);
   exit(1);
                    };
   aa->length= length ;
   aa->inner_length= inner_length ;

if ( length > 0 ) {
   aa->index=malloc(sizeof(int)*length);
   aa->values=malloc(sizeof(double)*length);
  } else {
   aa->values=NULL;
  }
}

/**************************************************************************************/
void read_sparse_values_type(sparse_values_type aa){
 
 if (aa.length<=0) {
   printf("PE%i:\t error in routine read_sparse_values_type:");
   printf("PE%i:\t length=%d \n",my_rank, aa.length);
   printf("PE%i:\t is less than 0!");
       exit_MPI(1);
   exit(1);
                    };

   read_sparse_values_type_kernel(aa.index, aa.values, aa.length);
}
/**************************************************************************************/
void read_sparse_values_type_kernel(int * index , double * aa, int length) {
        int i ;
        for (i=0; i<length; i++) {
// not finished
               scanf( "%f",&aa[i]);
        }
}

/**************************************************************************************/
void write_sparse_values_type(char string[], sparse_values_type aa){

  printf("PE%i:\t \n",my_rank);
  printf("PE%i:\t %s\n",my_rank,string);
 
 if (aa.length< 0) {
   printf("PE%i:\t error in routine write_sparse_values_type:");
   printf("PE%i:\t length=%d \n",my_rank, aa.length);
   printf("PE%i:\t is less than 0!",my_rank);
       exit_MPI(1);
   exit(1);
                    };

   write_sparse_values_type_kernel(aa.index, aa.values, aa.length, aa.inner_length);
}
/**************************************************************************************/
void write_sparse_values_type_kernel( int * index, double * aa, int length, int inner_length) {
        int i ;
               printf("PE%i:\t#inner part inner_length=%d  \n",my_rank,inner_length);
        for (i=0; i<inner_length; i++) {
               printf("PE%i:\t%d %d %f \n",my_rank,i,index[i],aa[i]);
        }
               printf("PE%i:\t#halo part length=%d  \n",my_rank,length-inner_length);
        for (i=inner_length; i<length; i++) {
               printf("PE%i:\t%d %d %f \n",my_rank,i,index[i],aa[i]);
        }
               printf("PE%i:\t \n",my_rank);
}


/**************************************************************************************/
void dealloc_sparse_values_type(sparse_values_type * sparse_values){
 if ( sparse_values->length > 0 ) {
   free(sparse_values->values); sparse_values->index=NULL; 
   free(sparse_values->values); sparse_values->values=NULL;
 }
   sparse_values->length=0;
}


/**************************************************************************************/
void set_sparse_values(  sparse_values_type * aa, int jmin, int kmin, int jmax, int kmax, int jmx_glob) {
      int ii, num,  jj, kk ;
      int num_row_elements ;

   if   ( aa->length < (kmax-kmin)*(jmax-kmin) ) {
           printf("PE%i:\t error in routine set_sparse_values: \n");
           printf("PE%i:\t length= %d \n",my_rank,aa->length);
           printf("PE%i:\t is not large enough \n ",my_rank);
           printf("PE%i:\t must be not less than (kmax-kmin)*(jmax-kmin)=%d \n ",my_rank,(kmax-kmin)*(jmax-kmin));
       exit_MPI(1);
           exit(1);
   }

 set_sparse_values_kernel(aa->index, aa->values, &(aa->length), &(aa->inner_length), jmin, kmin, jmax, kmax, jmx_glob); 
}
/**************************************************************************************/
void set_sparse_values_kernel(int * index, double * aa, int * length,int * inner_length, int jmin, int kmin, int jmax, int kmax, int jmx_glob) {         
      int ii, num,  jj, kk ;
      int num_row_elements ;
      int ind;

      ii=-1;
      num=-1;

           printf("PE%i:\t set_sparse_values_kernel:\n",my_rank);
           printf("PE%i:\t jmin=%d jmax=%d, kmin=%d kmax=%d \n",my_rank,jmin,jmax,kmin,kmax);
           printf("PE%i:\t  length=%d  \n",my_rank,*length);

     kk=kmin;
     for( jj=jmin; jj<=jmax;jj++ ) {
      ii=ii+1;
      ind=jj+jmx_glob*kk; // must be consistent with the matrix set up
      index[ii]=ind ;
      aa[ii]=(double)(jj-jmin)/(double)(jmax-jmin) ;
   //        printf("PE%i:\t %d %d   %d %d %f\n",my_rank,jj,kk,ii,index[ii],aa[ii]);
     }
     kk=kmax;
     for( jj=jmin; jj<=jmax;jj++ ) {
      ii=ii+1;
      ind=jj+jmx_glob*kk;
      index[ii]=ind ;
      aa[ii]=(double)(jj-jmin)/(double)(jmax-jmin) ;
   //        printf("PE%i:\t %d %d   %d %d %f\n",my_rank,jj,kk,ii,index[ii],aa[ii]);
     }

     jj=jmin;
   for (kk=kmin+1; kk<=kmax-1; kk++){
      ii=ii+1;
      ind=jj+jmx_glob*kk;
      index[ii]=ind ;
      aa[ii]=(double)(jj-jmin)/(double)(jmax-jmin) ;
   //        printf("PE%i:\t %d %d   %d %d %f\n",my_rank,jj,kk,ii,index[ii],aa[ii]);
   }

     jj=jmax;
   for (kk=kmin+1; kk<=kmax-1; kk++){
      ii=ii+1;
      ind=jj+jmx_glob*kk;
      index[ii]=ind ;
      aa[ii]=(double)(jj-jmin)/(double)(jmax-jmin) ;
   //        printf("PE%i:\t %d %d   %d %d %f\n",my_rank,jj,kk,ii,index[ii],aa[ii]);
   }
  if( ii < *length ) { 
     *length=ii+1;
     *inner_length=*length;
     }
  else {
           printf("PE%i:\t error in routine set_sparse_values_kernel:");
           printf("PE%i:\t length= %d \n",my_rank,*length);
           printf("PE%i:\t is not large enough ");
       exit_MPI(1);
           exit(1);
     }
}

/**************************************************************************************/
void sparse_values_to_sparse_values(sparse_values_type bb, sparse_values_type aa){
  if (aa.length != bb.length){
          printf("PE%i:\t error in routine sparse_values_to_sparse_values:");
          printf("PE%i:\t aa.length= %d ",my_rank, aa.length);
          printf("PE%i:\t is different from ");
          printf("PE%i:\t bb.length= %d \n",my_rank, bb.length);
       exit_MPI(1);
          exit(1);
  }
   sparse_values_to_sparse_values_kernel(bb.index, bb.values,aa.index, aa.values, aa.length);
}
/**************************************************************************************/
void sparse_values_to_sparse_values_kernel(int * bb_index, double * bb, int * aa_index, double * aa, int length){
        int i;
        for (i=0; i<length; i++){
               bb_index[i] = aa_index[i];
               bb[i] = aa[i];
        }
}
/**************************************************************************************/


